#include <iostream>
#include <signal.h>
#include <cstring>
#include <cerrno>
#include <unistd.h>
#include <cstdio>
#include <cstdlib>

const char *get_nom_signal(int s) {
  switch (s) {
  case SIGHUP:
    
    return "SIGHUP";
    break;
  case SIGINT:
    return "SIGINT";
  case SIGQUIT:
    return "SIGINT";
  case SIGILL:
    return "SIGILL";
  case SIGABRT:
    return "SIGABRT";
  case SIGFPE:
    return "SIGFPE";
  case SIGKILL:
    return "SIGKILL";
  case SIGSEGV:
    return "SIGSEGV";
  case SIGPIPE:
    return "SIGPIPE";
  case SIGALRM:
    return "SIGALRM";
  case SIGTERM:
    return "SIGTERM";
  case SIGUSR1:
    return "SIGUSR1";
  case SIGUSR2:
    return "SIGUSR2";
  case SIGCHLD:
    return "SIGCHLD";
  case SIGCONT:
    return "SIGCONT";
  case SIGSTOP:
    return "SIGSTOP";
  case SIGTSTP:
    return "SIGTSTP";
  case SIGTTIN:
    return "SIGTTIN";
  case SIGTTOU:
    return "SIGTTOU";
  default:
    return "UNKNOWN";
  }
}

void fct_signal(int s) {
  fprintf(stdout, "J'ai recu le signal %s et je me termine\n", get_nom_signal(s));
  fflush(stdout);
  exit(1);
}

typedef void (*sighandler_t)(int);

int main(int argc, char *argv[]) {
  int i;
  sighandler_t sh;

  for (i=1; i<30; i++) {
    if ((i!= SIGKILL)
	&&(i != SIGSTOP)
	&&(i != SIGCONT))
      {
	sh = signal(i, fct_signal);
	if (sh == SIG_ERR) {
	  fprintf(stderr,
		  "La redirection du signal %s %d produit l'erreur %s\n",
		  get_nom_signal(i), i, strerror(errno)
		  );
	}
      }
  }

  i = 0;
  while (1) {
    sleep(rand()%5);
    fprintf(stdout, "Je travaille %d\n", i++);
    fflush(stdout);
  }
  
  return 0;
}
